/*
 *	GUIgenerate.js
 *	Cycling '74 - 2008
 *	ej
 *
 *	This piece of code generate UI objects in order to communicate with a pluggo transformed patch.
 *
 */
 
autowatch = 1;				// just to make debugging easier
var ppList = new Array();	// our list of params

// This is almost what a pp object can handle
function pp()
{
	this.name;
	this.hidden = false;
	this.min;
	this.max;
	this.unit;
	this.choices;
	this.choicesvalues;
	/* imrovements suggestions:
		- storing colors "schemes" like c2...c5
		- fixed keyword could be stored
	*/
}

// store the parms in our ppList Array.
function list()
{
	// the incoming list looks like this:
	//	1 Gain 0. 1.		or
	//	2 Gain				or
	//	3 hidden Toto 0 3	or
	//	4 Titi 0 2 choices a b c
	var idx = 0;
	var i = arguments[idx++];

	if (ppList[i] == undefined)
		ppList[i] = new pp();	// create a internal representation of the pp arguments if it doesn't exist yet
	
	if (idx < arguments.length)	
		ppList[i].name = arguments[idx++];

	if ((idx + 1) < arguments.length) {	// store min/max
		ppList[i].min = arguments[idx++];
		ppList[i].max = arguments[idx++];
	} else {
		ppList[i].min = 0;	// or use default values
		ppList[i].max = 1;
	}

	// If the next thing is "choices" we need to create a menu.
	if (idx < arguments.length) {
		if (arguments[idx] == "choices")
			ppList[i].choices = true;
		else {
			ppList[i].choices = false;		// it's a simple slider
			ppList[i].unit = arguments[idx];
		}
	}
	
	if (ppList[i].choices) { // store the menu items
		idx++;
		ppList[i].choicesvalues = new Array();
		while (idx < arguments.length)
			ppList[i].choicesvalues[ppList[i].choicesvalues.length] = arguments[idx++];
	
	}
}

function hidden(idx, v)
{
	// set teh hidden property of the pp objects
	if (ppList[idx] == undefined)
		ppList[idx] = new pp();
	
	ppList[idx].hidden = v ? true : false;
}

function dump()
{
	// this is just for debugging puropose.
	for (var i = 1; i < ppList.length; i++)
		post(ppList[i].name, ppList[i].min, ppList[i].max, ppList[i].unit, ppList[i].hidden, "\n");
}

function create()
{
	var i, j, k, y, tmp;
	
	y = 5;
	
	// create the comment label
	this.patcher.message("script", "newobject", "comment", 
							"@varname", "slotname_label", 
							"@presentation_rect", 10, y, 130, 20, 
							"@patching_rect", 10, y, 130, 20, 
							"@presentation", 1,
							"@text", "Preset"
							);
	this.patcher.message("script", "newobject", "umenu", 
							"@varname", "slotname", 
							"@presentation_rect", 140, y, 140, 20, 
							"@patching_rect", 140, y, 140, 20, 
							"@presentation", 1
							);
			
							
	for (i = k = 1 ; i < ppList.length; i++) {
		y = k * 23 + 5;	// y positionning
		
		if (! ppList[i].hidden) {
			// create the comment label
			this.patcher.message("script", "newobject", "comment", 
									"@varname", i + "_label", 
									"@presentation_rect", 10, y, 130, 20, 
									"@patching_rect", 10, y, 130, 20, 
									"@presentation", 1,
									"@text", ppList[i].name
									);
	
			if (! ppList[i].choices) {
				this.patcher.message("script", "newobject", "multislider", 
										"@varname", i + "_UI", 
										"@presentation_rect", 140, y, 140, 20, 
										"@patching_rect", 140, y, 140, 20, 
										"@presentation", 1,
										"@orientation", 0,
										"@contdata", 1
										);
				tmp = this.patcher.getnamed(i + "_UI");
				tmp.message("setminmax", ppList[i].min, ppList[i].max);	// set slider range
			} else {
				// create umenu
				this.patcher.message("script", "newobject", "umenu", 
								"@varname", i + "_UI", 
								"@presentation_rect", 140, y, 140, 20, 
								"@patching_rect", 140, y, 140, 20, 
								"@presentation", 1
								);
				tmp = this.patcher.getnamed(i + "_UI");
				// fill it
				tmp.message("clear");
				for (j = 0; j < ppList[i].choicesvalues.length; j++)
					tmp.message("append", ppList[i].choicesvalues[j]);
			}
			
			if (ppList[i].unit != undefined) {
				// create unit comment
				this.patcher.message("script", "newobject", "comment", 
								"@varname", i + "_unitlabel", 
								"@presentation_rect", 280, y, 130, 20, 
								"@patching_rect", 280, y, 130, 20, 
								"@presentation", 1,
								"@text", ppList[i].unit,
								"@fixwidth", 1 /*  so it resize the comment after creating it */
								);
			}
			k++;	// increment if the pp2pattr was not hidden
		}
	}
	
	// force pattr to bind to the newly created UI
	messnamed("rebinding", "bang");	// send a bang to the receives "rebinding"
}


function remove()
{
	var tmp;
	for (var i = 1; i < ppList.length; i++) {
		tmp = this.patcher.getnamed("slotname_label");
		if (tmp)
			this.patcher.remove(tmp);
		tmp = this.patcher.getnamed("slotname");
		if (tmp)
			this.patcher.remove(tmp);
		tmp = this.patcher.getnamed(i + "_UI");
		if (tmp)
			this.patcher.remove(tmp);
			
		tmp = this.patcher.getnamed(i + "_label");
		if (tmp)
			this.patcher.remove(tmp);

		tmp = this.patcher.getnamed(i + "_unitlabel");
		if (tmp)
			this.patcher.remove(tmp);
	}
}

function clear()
{
	ppList = new Array();
}